<?php
// -----------------------------------------------------------------------
//
// $Id: update.php 193 2012-04-03 09:04:45Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

$invalid = preg_match('`(ftp|http|www)`i', $_SERVER['QUERY_STRING']);
if ($invalid != false)
{
    exit('Invalid query string. Exiting...');
}

error_reporting(E_ALL);

include('./../includes/config.php');
if (defined('SQL_TYPE') && defined('SQL_HOST') && defined('SQL_PORT') && defined('SQL_DATABASE') && defined('SQL_USER') && defined('SQL_PASSWORD'))
{
    switch (SQL_TYPE)
    {
        case 'mysql':
            include('./../includes/mysql.php');
            $sql = new mysql;
            break;
        case 'pgsql':
            include('./../includes/pgsql.php');
            $sql = new pgsql;
            break;
        case 'sqlite':
            include('./../includes/sqlite.php');
            $sql = new sqlite;
            break;
    }
}
include('./../includes/function.php');

if (strcmp(get_phpversion(), '5.4.0') < 0)
{
    ini_set('magic_quotes_runtime', 0);
    if (get_magic_quotes_gpc())
    {
        $_GET = strip_input_data($_GET);
        $_POST = strip_input_data($_POST);
        $_COOKIE = strip_input_data($_COOKIE);
    }
}
if (defined('SQL_TYPE') && SQL_TYPE != 'sqlite')
{
    $_GET = slash_input_data($_GET);
    $_POST = slash_input_data($_POST);
    $_COOKIE = slash_input_data($_COOKIE);
}

$content = '';
$error = '';

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
  "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>GENU - Update</title>
<link href="./../templates/default/style.css" type="text/css" rel="stylesheet" />
<!--[if IE 6]><link href="./../templates/default/ie6.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 7]><link href="./../templates/default/ie7.css" type="text/css" rel="stylesheet"><![endif]-->
<!--[if IE 8]><link href="./../templates/default/ie8.css" type="text/css" rel="stylesheet"><![endif]-->
<meta http-equiv="content-language" content="en" />
<meta http-equiv="content-type" content="application/xhtml+xml; charset=iso-8859-1" />
</head>
<body>
<div class="pageMain">
  <div class="pageLeft">
    <div class="leftLogo"><img src="./../images/logo.png" alt="." title="GENU" /></div>
  </div>
  <div class="pageRight">';

if (isset($_POST['update']))
{
    // 2012.0
    if ($_POST['version'] < 5)
    {
        $handle1 = (defined('SQL_TYPE') && SQL_TYPE == 'sqlite') ? './sql/updates/2012.0/2012.0-sqlite.sql' : './sql/updates/2012.0/2012.0.sql';
        if ($fp1 = @fopen($handle1, 'rb'))
        {
            $content .= fread($fp1, filesize($handle1));
            fclose($fp1);
        }
        else
        {
            $error .= 'Unable to open "' . $handle1 . '" file.<br />';
        }
    }

    // 2012.1
    if ($_POST['version'] < 7)
    {
        $handle2 = (defined('SQL_TYPE') && SQL_TYPE == 'sqlite') ? './sql/updates/2012.1/2012.1-sqlite.sql' : './sql/updates/2012.1/2012.1.sql';
        if ($fp2 = @fopen($handle2, 'rb'))
        {
            $content .= fread($fp2, filesize($handle2));
            fclose($fp2);
        }
        else
        {
            $error .= 'Unable to open "' . $handle2 . '" file.<br />';
        }
    }

    // 2012.2
    if ($_POST['version'] < 8)
    {
        if (defined('SQL_TYPE') && SQL_TYPE == 'mysql')
        {
            $handle3 = './sql/updates/2012.2/2012.2-mysql.sql';
        }
        elseif (defined('SQL_TYPE') && SQL_TYPE == 'pgsql')
        {
            $handle3 = './sql/updates/2012.2/2012.2-pgsql.sql';
        }
        else
        {
            $handle3 = './sql/updates/2012.2/2012.2-sqlite.sql';
        }
        if ($fp3 = @fopen($handle3, 'rb'))
        {
            $content .= fread($fp3, filesize($handle3));
            fclose($fp3);
        }
        else
        {
            $error .= 'Unable to open "' . $handle3 . '" file.';
        }
    }

    if ($error)
    {
        echo '
    <div class="rightMain">' . $error . '</div>';
    }
    else
    {
        if ($_POST['version'] == 8)
        {
            echo '
        <div class="rightMain">No table needs to be updated.<br /><br />Please remove the <span style="font-style: italic">install/</span> folder from your webserver.<br /><br />Go to the <a href="./../index.php" title="Home">index page</a> of your website.</div>';
        }
        else
        {
            preg_match_all('`(ALTER|CREATE|DROP|INSERT)[^;]+;`', $content, $matches);
            $queries = $matches[0];
            for ($i = 0; $i < count($queries); $i++)
            {
                $sql->query($queries[$i]);
            }
            echo '
        <div class="rightMain">Tables updated successfully.<br /><br />The update is finished, please remove the <span style="font-style: italic">install/</span> folder from your webserver.<br /><br />Go to the <a href="./../index.php" title="Home">index page</a> of your website.</div>';
        }
    }
}
else
{
    echo '
    <div class="rightMain">
      Welcome to GENU update.<br /><br />You must have a working GENU installation. Please read <a href="./../readme.txt" title="readme.txt">readme.txt</a> before continuing.<br /><br />
      <form method="post" action="./update.php">
        <div class="formLeft">Current version:</div>
        <div class="formRight"><select name="version"><option value="1">2007.0</option><option value="2">2007.1</option><option value="3">2007.2</option><option value="4">2009.0</option><option value="5">2010.0</option><option value="6">2012.0</option><option value="7">2012.1</option><option value="8">2012.2</option></select></div>
        <div class="formLeft">&nbsp;</div>
        <div class="formRight"><input type="submit" value="Update" name="update" /></div>
      </form>
    </div>';
}

echo '
    <div class="rightBottom">Back to home</div>
  </div>
</div>
<div class="pageBottom"><a href="http://www.gnew.fr/" title="GENU">GENU</a> 2012.3, Copyright &copy; 2003-2012 Raoul Proen&ccedil;a</div>
</body>
</html>';

?>