<?php
// -----------------------------------------------------------------------
//
// $Id: send.php 151 2012-03-25 17:30:52Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['NEWS_SEND_TITLE']);

// Send function enabled ?
if ($settings['send_news'] == 0)
{
    error_template($lang['NEWS_SEND_DISABLED']);
}
// From send form ?
elseif (isset($_POST['send']))
{
    $error = '';
    if (!trim($_POST['user_name']))
    {
        $error .= $lang['NO_USER_NAME'];
    }
    if (!trim($_POST['user_email']))
    {
        $error .= $lang['NO_USER_EMAIL'];
    }
    else
    {
        if (check_email($_POST['user_email']))
        {
            $user_email = $_POST['user_email'];
        }
        else
        {
            $error .= $lang['INVALID_USER_EMAIL'];
        }
    }
    if (!trim($_POST['friend_email']))
    {
        $error .= $lang['NO_FRIEND_EMAIL'];
    }
    else
    {
        if (check_email($_POST['friend_email']))
        {
            $friend_email = $_POST['friend_email'];
        }
        else
        {
            $error .= $lang['INVALID_USER_EMAIL'];
        }
    }
    if ($error)
    {
        error_template($error);
    }
    else
    {
        $sql->query('SELECT news_subject, news_text
                     FROM ' . TABLE_NEWS . '
                     WHERE news_id = \'' . $_POST['news_id'] . '\'');
        $table_news = $sql->fetch();
        $header = 'From: ' . html_entity_decode($settings['sender_name'], ENT_QUOTES, 'ISO-8859-1') . ' <' . $settings['sender_email'] . '>' . "\n";
        $header .= 'Reply-To: ' . html_entity_decode($_POST['user_name'], ENT_QUOTES, 'ISO-8859-1') . ' <' . $user_email . '>' . "\n";
        $header .= 'X-Mailer: PHP/' . phpversion() . "\n";
        $header .= 'MIME-Version: 1.0' . "\n";
        if (isset($_POST['html_email']))
        {
            $subject = sprintf($lang['NEWS_SEND_SUBJECT'], $settings['sitename']);
            $header .= 'Content-Type: text/html; charset=iso-8859-1' . "\n";
            $news_text = undo_escape_sequences($table_news['news_text']);
            $news_text = str_replace('./..', $settings['siteurl'], $news_text);
            $message = sprintf($lang['NEWS_SEND_HTML'], $_POST['user_name'], $table_news['news_subject'], $news_text, $settings['siteurl'], $settings['sitename']);
        }
        else
        {
            $subject = sprintf($lang['NEWS_SEND_SUBJECT'], html_entity_decode($settings['sitename'], ENT_QUOTES, 'ISO-8859-1'));
            $header .= 'Content-Type: text/plain; charset=iso-8859-1' . "\n";
            $news_text = html_entity_decode($table_news['news_text'], ENT_QUOTES, 'ISO-8859-1');
            $news_text = str_replace('./..', $settings['siteurl'], $news_text);
            $message = sprintf($lang['NEWS_SEND_PLAIN'], html_entity_decode($_POST['user_name'], ENT_QUOTES, 'ISO-8859-1'), html_entity_decode($table_news['news_subject'], ENT_QUOTES, 'ISO-8859-1'), $news_text, $settings['siteurl']);
        }
        mail($friend_email, $subject, $message, $header);
        success_template($lang['NEWS_SEND_SUCCESS'], './../index.php');
    }
}
// Send form
else
{
    // Check query
    if (!empty($_GET['news_id']))
    {
        $sql->query('SELECT news_id
                     FROM ' . TABLE_NEWS . '
                     WHERE news_id = \'' . $_GET['news_id'] . '\'
                     AND news_active = \'1\'');
        $table_news = $sql->fetch();
        // Check news
        if (!$table_news['news_id'])
        {
            error_template($lang['NEWS_SEND_ERROR']);
        }
        else
        {
            $template->set_file('send', 'news/send.htpl');
            $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                                     'FORM_FRIEND_EMAIL' => $lang['FORM_FRIEND_EMAIL'],
                                     'FORM_HTML_EMAIL' => $lang['FORM_HTML_EMAIL'],
                                     'FORM_USER_EMAIL' => $lang['FORM_USER_EMAIL'],
                                     'FORM_USER_NAME' => $lang['FORM_USER_NAME'],
                                     'NEWS_ID' => $_GET['news_id'],
                                     'NEWS_SEND_HEADER' => $lang['NEWS_SEND_HEADER'],
                                     'SEND' => $lang['SEND']));
            // User logged ?
            if ($_SESSION['user_id'] != 0)
            {
                $template->set_var(array('USER_EMAIL' => $users['user_email'],
                                         'USER_NAME' => $users['user_name']));
            }
            $template->parse('send');
        }
    }
    else
    {
        error_template($lang['NEWS_SEND_ERROR']);
    }
}

page_footer();

?>