<?php
// -----------------------------------------------------------------------
//
// $Id: vote.php 2 2012-01-24 17:39:30Z raoul $
//
// Copyright (C) 2003-2012 Raoul Proena
// License: GNU GPL version 3 (see copying.txt file)
// Website: http://www.gnew.fr/
//
// -----------------------------------------------------------------------
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// -----------------------------------------------------------------------

include('./../includes/common.php');

page_header($lang['POLLS_VOTE_TITLE']);

// From vote form ?
if (isset($_POST['add_vote']))
{
    // User logged ?
    if ($_SESSION['user_id'] != 0)
    {
        $error = '';
        if (empty($_POST['answer_id']))
        {
            $error .= $lang['NO_ANSWER_TEXT'];
        }
        // Anti-flood - x days
        $sql->query('SELECT MAX(vote_date) AS last_vote
                     FROM ' . TABLE_VOTES . '
                     WHERE question_id = \'' . $_POST['question_id'] . '\'
                     AND user_id = \'' . $_SESSION['user_id'] . '\'');
        $table_votes = $sql->fetch();
        if ($table_votes['last_vote'] >= (time() - ($settings['votes_interval'] * 24 * 3600)))
        {
            $error .= sprintf($lang['POLLS_VOTE_ERROR1'], $settings['votes_interval']);
        }
        if ($error)
        {
            error_template($error);
        }
        else
        {
            $sql->query('UPDATE ' . TABLE_ANSWERS . '
                         SET answer_votes = answer_votes + 1
                         WHERE answer_id = \'' . $_POST['answer_id'] . '\'');
            $sql->query('UPDATE ' . TABLE_QUESTIONS . '
                         SET question_votes = question_votes + 1
                         WHERE question_id = \'' . $_POST['question_id'] . '\'');
            $sql->query('UPDATE ' . TABLE_USERS . '
                         SET user_votes = user_votes + 1
                         WHERE user_id = \'' . $_SESSION['user_id'] . '\'');
            $sql->query('INSERT INTO ' . TABLE_VOTES . ' (question_id, answer_id, user_id, vote_date)
                         VALUES (\'' . $_POST['question_id'] . '\', \'' . $_POST['answer_id'] . '\', \'' . $_SESSION['user_id'] . '\', \'' . time() . '\')');
            success_template($lang['POLLS_VOTE_SUCCESS'], './../polls/view.php?question_id=' . $_POST['question_id']);
        }
    }
    else
    {
        error_template($lang['POLLS_VOTE_ERROR2']);
    }
}
// Vote form
else
{
    // Check query
    if (!empty($_GET['question_id']))
    {
        $template->set_file('vote', 'polls/vote.htpl');
        $template->set_block('vote', 'ANSWERS_BLOCK', 'answers');
        $sql->query('SELECT answer_id, answer_text
                     FROM ' . TABLE_ANSWERS . '
                     WHERE question_id = \'' . $_GET['question_id'] . '\'
                     ORDER BY answer_id');
        while ($table_answers = $sql->fetch())
        {
            $template->set_var(array('ANSWER_ID' => $table_answers['answer_id'],
                                     'ANSWER_TEXT' => $table_answers['answer_text']));
            $template->parse('ANSWERS_BLOCK', 'answers', true);
            $answers_exist = true;
        }
        if (isset($answers_exist))
        {
            $sql->query('SELECT question_comment, question_text
                         FROM ' . TABLE_QUESTIONS . '
                         WHERE question_id = \'' . $_GET['question_id'] . '\'');
            $table_questions = $sql->fetch();
            $template->set_var(array('BACK_HOME' => $lang['BACK_HOME'],
                                     'POLLS_VOTE_HEADER' => $lang['POLLS_VOTE_HEADER'],
                                     'POLLS_VOTE_OTHER' => $lang['POLLS_VOTE_OTHER'],
                                     'POLLS_VOTE_RESULTS' => $lang['POLLS_VOTE_RESULTS'],
                                     'QUESTION_COMMENT' => $table_questions['question_comment'],
                                     'QUESTION_ID' => $_GET['question_id'],
                                     'QUESTION_TEXT' => $table_questions['question_text'],
                                     'VOTE' => $lang['VOTE']));
            $template->parse('vote');
        }
        else
        {
            error_template($lang['POLLS_VOTE_ERROR3']);
        }
    }
    else
    {
        error_template($lang['POLLS_VOTE_ERROR3']);
    }
}

page_footer();

?>